#include <bits/stdc++.h>
#define pb push_back
using namespace std;

long long p, q;
unsigned long long area;
// w < h
bool check(unsigned long long w, unsigned long long h) {
    unsigned long long c = 1, res1 = 0, res2 = 0;
    while(h != 0 && w != 0) {
        if(w > h) {
            if(c % 2 == 0) {
                w -= h;
                res2 += 1LL * h * h;
            } else {
                w -= h;
                res1 += 1LL * h * h;
            }
        } else {
            if(c % 2 == 0) {
                h -= w;
                res2 += 1LL * w * w;
            } else {
                h -= w;
                res1 += 1LL * w * w;
            }
        }
        c++;
    }
    if(((res1 == p && res2 == q) || (res1 == q && res2 == p))) return true;
    else return false;
}


int main() {
    cin >> p >> q;
    
    if(p < q) {cout << -1 << endl; return 0;}
    if(p == q  || p + 1 == q || q + 1 == p) {cout << 1 << " " << p + q << endl; return 0;}

    if(p + q < 940000000) {
        area = p + q;
        vector <pair<unsigned long long, unsigned long long>> a;

        for(int i = 1; i <= sqrt(area); i++) {
            if(area % i == 0) a.pb({i, area / i});
        }

        for(auto x: a) {
            if(check(x.first, x.second)) {cout << x.first << " " << x.second << endl; return 0;}
        }

        cout << -1 << endl;
        return 0;
    }

    unsigned long long ar = abs(p - q);
    if(sqrt(ar) * sqrt(ar) != ar) {cout << -1 << endl; return 0;}
    else if(ar != 0) {
        unsigned long long fs = sqrt(ar);
        unsigned long long area = p + q;
        vector <pair<unsigned long long, unsigned long long>> a;

        for(int i = 1; i <= sqrt(area); i++) {
            if(area % i == 0) a.pb({i, area / i});
        }
        for(auto x: a) {
            if(x.first == fs || x.second == fs) {cout << x.first << " " << x.second << endl; return 0;}
        }
    } 
    else {
        unsigned long long area = p + q;
        vector <pair<unsigned long long, unsigned long long>> a;

        for(int i = 1; i <= sqrt(area); i++) {
            if(area % i == 0) {cout << i << " " << area / i << endl; return 0;}
        }
    }

    cout << -1 << endl;

}