#include <bits/stdc++.h>

using namespace std;
using ll = long long;


ll size1;
vector<vector<ll>> a;
vector<bool> used;
vector<ll> krai;

void dfs(ll depth, ll ind){
    if(depth == size1){
        krai.push_back(ind);
        return 0;
    }
    used[ind] = true;
    for(ll i = 0; i < a[ind].size(); i++){
        if(!used[a[ind][i]]){
            dfs(depth+1, a[ind][i]);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ll n;
    cin >> n;
    a.resize(n);
    for (ll i = 0; i < n-1; i++) {
        ll u, v;
        cin >> u >> v;
        u--; v--;
        a[u].push_back(v);
        a[v].push_back(u);
    }
    queue<pair<ll, ll>> b;
    vector<bool> used(n, false);
    b.push({0, 0});
    ll ind1;
    while(!b.empty()){
        used[b.front().first] = true;
        for(ll i = 0; i < a[b.front().first].size(); i++){
            if(!used[a[b.front().first][i]]){
                b.push({a[b.front().first][i], b.front().second + 1});
            }
        }
        if(b.size() == 1){
            ind1 = b.front().first;
        }
        b.pop();
    }
    b.push({ind1, 1});
    for(ll i = 0; i < n; i++){
        used[i] = false;
    }
    while(!b.empty()){
        used[b.front().first] = true;
        for(ll i = 0; i < a[b.front().first].size(); i++){
            if(!used[a[b.front().first][i]]){
                b.push({a[b.front().first][i], b.front().second + 1});
            }
        }
        if(b.size() == 1){
            size1 = b.front().second;
        }
        b.pop();
    }
    cout << size1 << '\n';

}
