n = int(input())

# edges = [False]*(n+1)
adj = [[] for _ in range(n + 1)]
for _ in range(n - 1):
    u, v = map(int, input().split())

    # edges[u] = not edges[u]
    # edges[v] = not edges[v]

    adj[u].append(v)
    adj[v].append(u)

# TODO: Process the tree

l = n
a = [0] * n
b = [0] * n

edges = [x for x in range(n+1) if len(adj[x]) == 1]
#print(edges)


def wavefront(v, wave):
    if v in visited:
        return
    
    dists[v] = wave
    visited.add(v)
    for child in adj[v]:
        wavefront(child, wave+1)



def trace(cur):
    way = [cur]
    lvl = dists[cur]
    for l in reversed(range(lvl)):
        for v in adj[cur]:
            if dists[v] == l:
                way.append(v)
                cur = v
                break
    return tuple(way)


ways = []
for i in range(len(edges)):
    visited = set()
    dists = [None]*(n+1)
    wavefront(edges[i], 0)
    for j in range(i+1, len(edges)):
        #print(e1, e2)
        way = trace(edges[j])
        if len(way) != 1:
            ways.append(way)



# len_way = -float('INF')
# for way in ways:
#     if len(way) > len_way:
#         len_way = len(way)

max_len = len(max(ways, key=lambda x: len(x)))

ways = [way for way in ways if len(way) == max_len]

max_cities = 0
a, b = [], []
for i in range(len(ways)):
    for j in range(i+1, len(ways)):
        cur_len = len(set(ways[i]) | set(ways[j]))
        if cur_len > max_cities:
            a, b = ways[i], ways[j]
            max_cities = cur_len

print(max_len)
print(" ".join(str(x) for x in a))
print(" ".join(str(x) for x in b))
#print(max_cities)



# def trace(cur, prev, direction_up, way):
#     if cur in edges:
#         return way

#     for v in adj[cur]:
#         if v != prev and dists(v) < dists(cur)  :
#             trace(v, cur, direction, way+[v])

# print(l)
# print(" ".join(str(x) for x in a))
# print(" ".join(str(x) for x in b))
