fn main() {
    let mut input = String::new();

    std::io::stdin()
        .read_line(&mut input)
        .expect("Failed to read line");

    loop {
        input = String::new();

        std::io::stdin()
            .read_line(&mut input)
            .expect("Failed to read line");

        input = String::new();

        std::io::stdin()
            .read_line(&mut input)
            .expect("Failed to read line");
        
        if input.trim().is_empty() {
            break
        }

        let string = input.trim().to_owned();
        
        println!("{}", if game(string) { "Yes" } else { "No" })
    }

    
}

fn game(mut nums: String) -> bool {
    loop {
        play_move_of_1(&mut nums);

        //println!("{nums}");
        if let Some(x) = check_for_game_end(&nums) { return x };
        
        play_move_of_2(&mut nums);

        //println!("{nums}");
        if let Some(x) = check_for_game_end(&nums) { return x };
    }
}

fn check_for_game_end(nums: &String) -> Option<bool> {
    let mut prev = ' ';
    for i in nums.chars() {
        if i == prev {
            return Some(false)
        }
        prev = i
    }

    if nums.len() > 10 {
        return None
    }

    let mut nums_unique = Vec::new();

    for i in nums.chars() {
        for j in nums_unique.iter() {
            if &i == j {
                return None;
            }
        }

        nums_unique.push(i)
    }

    Some(true)
}

fn play_move_of_1(nums: &mut String) {
    for i in 2..nums.len() {
        if nums.chars().nth(i) == nums.chars().nth(i-2) {
            nums.remove(i);
            return
        }
    }

    nums.remove(0);
}

fn play_move_of_2(nums: &mut String) {
    for i in 2..nums.len() {
        if nums.chars().nth(i) == nums.chars().nth(i-2) {
            nums.remove(i-1);
            return
        }
    }

    for i in 4..nums.len() {
        if nums.chars().nth(i) == nums.chars().nth(i-3) && nums.chars().nth(i-1) == nums.chars().nth(i-4) {
            nums.remove(i-2);
            return
        }
    }

    nums.remove(0);
}