#include <bits/stdc++.h>
using namespace std;

bool solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;

    vector<int> last(10, -1);
    map<int, int> threats{};

    for (int i = 0; i < n; i++) {
        int digit = s[i] - '0';

        if (last[digit] >= 0) {
            threats[i - last[digit] - 1] += 1;
        }

        last[digit] = i;
    }

    int acc_count = 0;

    for (auto [dist, count] : threats) {
        acc_count += count;

        if (acc_count > dist) {
            return false;
        }
    }

    return true;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while(t--) {
        cout << (solve() ? "Yes" : "No") << "\n";
    }
}

/*
2.2...3..3...3..3

*/
