#include <bits/stdc++.h>
using namespace std;
bool get_initial_cake_parameters0(long long p, long long q, long long a, long long b){
    bool qu = false;
    long long in_sqr = p + q;
    while (in_sqr > 0){
        long long to_cutoff;
        if (a < b){
            to_cutoff = a;
            in_sqr -= to_cutoff*to_cutoff;
            b-=to_cutoff;
        }
        else{
            to_cutoff = b;
            in_sqr -= to_cutoff*to_cutoff;
            a-=to_cutoff;
        }
        if (!qu)
            p -= to_cutoff*to_cutoff;
        else
            q -= to_cutoff*to_cutoff;
        qu = !qu;
    }
    if (p < 0 || q < 0){
        return false;
    }
    else
        return true;
}
bool get_initial_cake_parameters(long long p, long long q, long long a, long long b){
    long long in_sqr = p + q;
    while (in_sqr > 0){
        
        if (a < b){
            in_sqr %= (a*a);
            p -= a*a*((b / a)/2 + (b / a) % 2);
            q -= a*a*((b / a)/2);
            b%=a;
        }
        else if (a == b){
            return true;
        }
        else{
            in_sqr %= (b*b);
            p -= b*b*((a / b)/2);
            q -= b*b*((a / b)/2 + (a / b) % 2);
            a%=b;
        }
        //cout << p << ' ' << q << ' ' << a << ' ' << b << endl;
        if (p < 0 || q < 0){
            return false;
        }
    }
    if (p < 0 || q < 0){
        return false;
    }
    else
        return true;
}
void bs(long long p, long long q){
    long long m, n;
    long long in_sqr = p + q;
    if (p == 0 || q == 0){
        long long side = (long long) sqrt(p+q);
        if (side*side == (p+q)){
            cout << side << ' ' << side;
            return;
        }
    }
    for (int i = 1; i <= sqrt(in_sqr); i++){
        if (in_sqr % i == 0){
            m = i;
            n = in_sqr / i;
            if (p < 1000000000 && q < 1000000000){
                if (get_initial_cake_parameters0(p, q, m, n)){
                    cout << m << ' ' << n;
                    return;
                }
            }
            else{
                //cout << m << ' ' << n << endl;
                if (get_initial_cake_parameters(p, q, m, n)){
                    cout << m << ' ' << n;
                    return;
                }
            }
        }
    }
    cout << -1;
}
int main() {
    long long p,q;
    cin >> p >> q;
    
    // TODO: process the data
    bs(p, q);
}