p, q = map(int, input().split())

area = p+q
arr = [i for i in range(1,int(area**0.5)+2) if area % i == 0]
# arr of dividers
if p < q:
    print(-1)
    exit()

def sim(n):
    # simulate the game
    m = area//n
    sp = 0
    pturn = True

    while n > 0 and m > 0:
        if n > m:
            if pturn: sp += int(m**2)
            n -= m
        else:
            if pturn: sp += int(n**2)
            m -= n

        pturn = not pturn
    
    return sp

i,j = 0, len(arr)-1
while i <= j:
    m = (i+j)//2
    sp = sim(arr[m])
    if sp > p:
        j = m-1
    elif sp < p:
        i = m+1
    else:
        print(arr[m], area//arr[m])
        exit()
        
print(-1)