n = int(input())

adj = [tuple(map(int,input().split())) for i in range(n-1)]

# TODO: Process the tree

connections = {i:[] for i in range(1,n+1)}
for i,j in adj:
    connections[i].append(j)
    connections[j].append(i)

routes = []

def rec(city, r):
    if len(connections[city]) == 1 and connections[city][0] in r:
        routes.append(r)
        return
    for i in connections[city]:
        if not i in r:
            rec(i, r+(i,))

for i in connections.keys(): # find cities with 1 connection
    if len(connections[i]) == 1:
        rec(i, (i,))

l = len(max(routes, key=len))
routes.sort(key=len, reverse=True)

a = []
b = []
rlen = len(routes)
max_set_len = 0
for i in range(rlen-1):
    for j in range(i,rlen):
        if len(routes[i]) != l or len(routes[j]) != l: break
        set_len = len(set(routes[i] + routes[j]))
        if set_len > max_set_len:
            max_set_len = set_len
            a = routes[i]
            b = routes[j]

print(l)
print(" ".join(list(map(str, a))))
print(" ".join(list(map(str, b))))