#include <bits/stdc++.h>
using namespace std;

struct Node {
    char c;
    int pr, nxt;
};
vector<Node> nodes;

int n;
string s;
int len;


bool slow(bool tu) {
    if (len < 2) return true;
    
    int cur = nodes[0].nxt;

    while (cur != 1) {

        if (nodes[nodes[cur].pr].c == 
            nodes[nodes[cur].nxt].c) {
            if (!tu) return false;
            cur = nodes[cur].nxt;
            continue;
        }

        nodes[nodes[cur].pr].nxt = nodes[cur].nxt;
        nodes[nodes[cur].nxt].pr = nodes[cur].pr;
        
        len--;
        bool there = slow(!tu);
        len++;

        nodes[nodes[cur].pr].nxt = cur;
        nodes[nodes[cur].nxt].pr = cur;

        if (tu == there) {
            return tu;
        }

        cur = nodes[cur].nxt;
            
    }
    return !tu;
}

void solve() {
    
    cin >> n;
    cin >> s;

    if (n >= 20) {
        printf("No\n");
        return;
    }
    bool here = true;
    for (int i = 0; i < n - 1; i++) {
        if (s[i] == s[i + 1]) here = false;
    }

    if (!here) {
        printf("No\n");
        return;
    }

    int cur = 0;

    for (int i = 0; i < n; i++) {
        nodes[cur].nxt = nodes.size();
        nodes.emplace_back(s[i], cur, -1);
        cur = nodes[cur].nxt;
    }

    nodes[cur].nxt = 1;
    nodes[1].pr = cur;

    

    len = n;
    
    bool ok = slow(true);

    printf(ok ? "Yes\n" : "No\n");


    
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    nodes.reserve(2000000);
    nodes.emplace_back('-', -1, -1);
    nodes.emplace_back('!', -1, -1);

    int t;
    cin >> t;
    while(t--)solve();
}