#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n;
    cin >> n;
    
    vector<vector<int>> adj(n + 1);
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    int mxdist = -1;
    for (int i = 1; i <= n; i++) {
        int d[n + 1] = {};
        d[i] = 1;

        queue<int> q;
        q.push(i);

        while (!q.empty()) {
            auto top = q.front();

            for (int ad : adj[top]) {
                if (d[ad] == 0) {
                    d[ad] = d[top] + 1;
                    mxdist = max(mxdist, d[ad]);
                    q.push(ad);
                }
            }

            q.pop();
        }
    }

    int mx = -1;
    vector<int> p1, p2;


    
    for (int v1 = 1; v1 <= n; v1++) {
        for (int u1 = v1 + 1; u1 <= n; u1++) {

            int pr[n + 1] = {};
            bool vis[n + 1] = {};
            vector<int> phere;
            int dist = 0;

            queue<int> q;
            q.push(v1);
            pr[v1] = -1;

            while (!q.empty()) {
                auto top = q.front();
                for (int ad : adj[top]) {
                    if (pr[ad] == 0) {
                        pr[ad] = top;
                        q.push(ad);
                    }
                    if (ad == u1) break;
                }
                q.pop();
            }

            int cur = u1;
            while (cur != -1) {
                vis[cur] = true;
                dist++;
                phere.push_back(cur);
                cur = pr[cur];
            }

            

            for (int v2 = 1; v2 <= n; v2++) {
                for (int u2 = v2 + 1; u2 <= n; u2++) {
                    while (!q.empty()) q.pop();
                    q.push(v2);

                    for (int i = 1; i <= n; i++) {
                        pr[i] = 0;
                    }

                    pr[v2] = -1;

                    while (!q.empty()) {
                        auto top = q.front();
                        for (int ad : adj[top]) {
                            if (pr[ad] == 0) {
                                pr[ad] = top;
                                q.push(ad);
                            }
                            if (ad == u2) break;
                        }
                        q.pop();
                    }
                    int heredist = dist;
                    vector<int> pthere;
                    cur = u2;
                    while (cur != -1) {
                        if (!vis[cur]) {
                            heredist++;
                        }
                        pthere.push_back(cur);
                        cur = pr[cur];
                    }

                    if (phere.size() == mxdist && pthere.size() == mxdist && heredist > mx) {
                        mx = heredist;
                        p1 = phere;
                        p2 = pthere;
                    }
                }
            }
        }
    }

    printf("%i\n", mxdist);
    for (int v : p1) {
        printf("%i ", v);
    }
    printf("\n");

    for (int v : p2) {
        printf("%i ", v);
    }
    printf("\n");
    
}
