def does_us_win(l):
    for i in range(len(l) - 2):
        if l[i] == l[i+1]:
            return True
    return False

def count_els(l: list[int]):
    res = dict()
    for i in l:
        res[i] = 1 if (res.get(i) == None) else res[i] + 1
    return res

# Returns two indexes of same numbers with smalest distance 
def smallest_dist_ids(l: list[int]):
    counts = count_els(l)
    short = {k: v for k, v in counts.items() if v > 1}

    for i in short:
        short[i] = [index for index, v in enumerate(l) if v == i]

    res = (-1, -1)
    min_d = 1000000 # ну типу найбільше число)
    for i in short.values():
        for index, j in enumerate(i[:len(i)-1]):
            for k in i[index:]:
                if k - j < min_d:
                    res = (j, k)

    return res

def vus_tern(l: list[int]):
    l.pop(smallest_dist_ids(l)[1])

def us_tern(l: list[int]):
    l.pop(smallest_dist_ids(l)[0]+1)

def solve():
    n = int(input())

    for _ in range(n):
        _ = input()
        s = [int(i) for i in input()]
        
        i = 0
        while True:
            if does_us_win(s):
                print("No")
                break
            if max(count_els(s).values()) == 1:
                print("Yes")
                break
            
            if i % 2 == 0:
                vus_tern(s)
            else:
                us_tern(s)
            
            i += 1

solve()