#include <bits/stdc++.h>
using namespace std;

double max(double a, double b)
{
    if (a > b)
        return a;
    return b;
}

long long get_x(long long n)
{
    double x = max(1, sqrt(n));
    //cout << round(x) << '\n';
    long long lx = round(x - 0.5);
    return lx;
}

bool check(long long x, long long p, long long q)
{
    long long n = p + q, x1, xq, xp;
    p -= x * x;
    long long cnt = 1;
    while (p > 0 && q > 0)
    {
        if (cnt % 2 == 0)
        {
            xp = get_x(p);
            p -= xp * xp;
        }
        else
        {
            xq = get_x(q);
            q -= xq * xq;
        }

        if (q > p && cnt % 2 == 1)
        {
            //cout << '\n';
            return 0;
        }
        if (q == p)
        {
            //cout << '\n';
            return 1;
        }

        cnt++;
        //cout << p << ' ' << q << '\n';
    }
    if (p < 0)
        p += xp;
    else if (q < 0)
        q += xq;
    //cout << p << ' ' << q << '\n';
    //cout << '\n';
    if (p == q)
        return 1;
    return 0;
}

long long search_side(long long p, long long q)
{
    for (long long i = round(sqrt(p)); i >= 1; --i)
    {
        if (check(i, p, q))
            return i;
    }
    return -1;
}

int main()
{
    long long p, q;
    cin >> p >> q;

    long long side1 = search_side(p, q);
    if (side1 == -1 || (p + q) % side1 != 0)
        cout << -1;
    else
        cout << side1 << ' ' << (p + q) / side1;


    return 0;
}
