#include <bits/stdc++.h>
using namespace std;

int dig_pos[10];
int q_pairs[10];

void solve() {
    int n; cin >> n;
    string s; cin >> s;

    for (int i = 0; i< 10; ++i){
        dig_pos[i] = q_pairs[i] = -1;
    }

    int q_pairs_len_0 = 0;
    for (int i = 1; i < n; ++i)
        if (s[i] == s[i-1])
            ++q_pairs_len_0;
    
    int max_dist = 0;
    for (int i = 0; i < n; ++i){
        if (dig_pos[s[i] - '0'] != -1)
            max_dist = max(max_dist, i - dig_pos[s[i] - '0'] - 1);
        dig_pos[s[i] - '0'] = i;

        q_pairs[s[i] - '0']++;
    }

    int res_q_pairs = 0;
    for (int i = 0; i < 10; ++i)
        if(q_pairs[i] != -1)
            res_q_pairs += q_pairs[i];

    int q_pairs_len_1 = 0;
    for (int i = 2; i < n; ++i)
        if (s[i] == s[i-2])
            ++q_pairs_len_1;
    
    bool are_len_1_touching = false;
    for (int i = 4; i < n; ++i)
        if (s[i] == s[i-2] && s[i] == s[i-4])
            are_len_1_touching = true;

    bool Us_wins_with_len_1 = (q_pairs_len_1 >= 3) || (q_pairs_len_1 == 2 && !are_len_1_touching);
    
    cout << ((res_q_pairs <= max_dist && !Us_wins_with_len_1 && q_pairs_len_0 < 2) ? "Yes\n" : "No\n");
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int t; cin >> t;
    while(t--)solve();
}