#pragma GCC optimize("O3")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"

ll uppow2(ll n){
    n--;
    n |= n>>1;
    n |= n>>2;
    n |= n>>4;
    n |= n>>8;
    n |= n>>16;
    n |= n>>32;
    n++;
    return n;
}

bool check(string s, bool first){
    vector<ll> cnt(10,0);
    ll mx=0;
    for (ll i=0;i<(ll)s.size()-1;i++){
        mx=max(mx,++cnt[s[i]]);
        if (s[i]==s[i+1]){
            return !first;
        }
    }
    mx=max(mx,++cnt[s.back()]);
    if (mx<=1){
        return first;
    }
    bool bl=false;
    for (ll i=0;i<s.size();i++){
        string s2;
        for (ll j=0;j<i;j++){
            s2.push_back(s[j]);
        }
        for (ll j=i+1;j<s.size();j++){
            s2.push_back(s[j]);
        }
        bl|=!check(s2,!first);
    }
    return bl;
}

void solve() {
    ll n;
    cin >> n;
    string s;
    cin >> s;
    bool ans = true;
     vector<ll> cnt(10,0);
    for (ll i=0;i<n;i++){
        cnt[s[i]-'0']++;
    }
    sort(rall(cnt));
    ll d=0;
    for (ll i=2;i<10;i++){
        d+=cnt[i];
    }
    if (cnt[0]+cnt[1]-d>=4){
        ans=false;
    }
    if (ans && n<=12){
        ans=check(s,true);
    }
    if (ans) {
        cout << "Yes" << endl;
    } else {
        cout << "No" << endl;
    }

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n,m,a,b,c,d;
    ll p,q;
    ll t;
    cin>>t;
    while (t--){
        solve();
    }
}
