#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

ll n, tin[600001], tout[600001], t, up[600001][20], dist[600001];
vector<ll> e[600001];

void lca(ll v, ll prew) {
  tin[v] = t++;
  up[v][0] = prew;
  for (ll i = 1; i < 20; i++)
    up[v][i] = up[up[v][i - 1]][i - 1];

  for (ll x : e[v]) {
    if (x != prew) {
      dist[x] = dist[v] + 1;
      lca(x, v);
    }
  }

  tout[v] = t++;
  return;
}

bool pernt(ll x, ll y)
{
  if (tin[x] < tin[y] && tout[x] > tout[y])
    return 1;
  return 0;
}

ll lth(ll x, ll y)
{
  if (pernt(y, x))
    swap(x, y);

  ll dx = x;

  for (ll i = 0; i < 20; i++)
  {
      if (pernt(up[x][i], y))
      {
      if (!i)
          return dist[y] + dist[dx] - dist[up[x][i]] * 2;
      
      x = up[x][i - 1];
      i = -1;
      } else if (pernt(x, y))
        return dist[y] - dist[x];
  }
}

vector<ll> path(ll x, ll y)
{
  if (pernt(y, x))
    swap(x, y);

  ll dx = x;
  vector<ll> res;

  for (ll i = 0; i < 20; i++) {
    if (pernt(up[x][i], y)) {
        if (!i)
        {
          x = up[x][0];
          break;
        }

      x = up[x][i - 1];
      i = -1;
    } 
    else if (pernt(x, y))
      break;
  }

  while (dx != x)
  {
    res.push_back(dx);
    dx = up[dx][0];
  }
  ll sz = res.size() + 1;
  res.push_back(x);
  while (y != x) {
    res.insert(res.begin() + sz, y);
    y = up[y][0];
  }

  return res;
}

void go() {
  cin >> n;
  for (ll i = 1; i < n; i++) {
    ll x, y;
    cin >> x >> y;
    e[x].push_back(y);
    e[y].push_back(x);
  }

  lca(1, 1);

  //cout << lth(1, 2) << '\n';

  vector<vector<ll>> ans;
  ll mx = 0;
  for (ll i = 1; i <= n; i++)
  {
    for (ll j = 1; j <= n && j != i; j++) 
    {
      ll l = lth(i, j);
      if (l > mx)
      {
        mx = l;
        ans.clear();
      } 
      if (l == mx)
          ans.push_back(path(i, j));
    }
  }
  
  vector<ll> a, b;
  ll unc = 0;
  for (ll i = 0; i < ans.size(); i++) {
    for (ll j = 0; j < ans.size(); j++) {
      map<ll, bool> sk;

      for (ll g = 0; g < ans[i].size(); g++)
        sk[ans[i][g]] = sk[ans[j][g]] = 1;

      if (sk.size() > unc) {
        unc = sk.size();
        a = ans[i];
        b = ans[j];
      }
    }
  }

  cout << mx + 1 << '\n';
  for (auto i : a)
    cout << i << ' ';
  cout << '\n';
  for (auto i : b)
    cout << i << ' ';
  cout << '\n';
  return;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int count_tests = 1;
  //cin >> count_tests;
  while (count_tests--)
    go();

  return 0;
}
