#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

bool check_game(ll n, ll m, ll p, ll q) {
    ll vus_sum = 0, us_sum = 0;
    bool vus_turn = true;
    while (n > 0 && m > 0) {
        ll square_size = min(n, m);
        ll square_area = square_size * square_size;
        
        if (vus_turn) vus_sum += square_area;
        else us_sum += square_area;
        
        if (vus_sum == p && us_sum == q) return true;
        if (vus_sum > p || us_sum > q) return false;
        
        if (n > m) n -= square_size;
        else m -= square_size;
        
        vus_turn = !vus_turn;
    }
    return false;
}

int main() {
    ll p, q;
    cin >> p >> q;
    ll total = p + q;
    
    for (ll n = 1; n * n <= total; ++n) {
        if (total % n == 0) {
            ll m = total / n;
            if (check_game(n, m, p, q)) {
                cout << n << " " << m << endl;
                return 0;
            }
            if (check_game(m, n, p, q)) {
                cout << m << " " << n << endl;
                return 0;
            }
        }
    }
    cout << -1 << endl;
    return 0;
}
