#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
const ll INF = 6*1e5;
vector<ll> graph[INF];
ll maxi = 0;
ll dfs(ll v, ll p){
    pair<ll, ll> temp = {-1, -1};
    for(auto element : graph[v]){
        if(element==p) continue;
        ll t = dfs(element, v);
        if(t>temp.second) temp.second = t;
        if(temp.first<temp.second) swap(temp.first, temp.second);
    }
    if(temp.first!=-1 && temp.second!=-1) maxi=max(maxi, temp.first+temp.second+1);
    if(temp.first!=-1) return temp.first+1;
    else return 1;
}
vector<vector<ll>> need;
stack<ll> s;
void dfs1(ll v, ll p){
    s.push(v);
    if(s.size()==maxi){
        vector<ll> temp;
        while(!s.empty()){
            ll t = s.top();
            s.pop();
            temp.push_back(t);
        }
        for(ll i = temp.size()-1; i>=0; i--) s.push(temp[i]);
        need.push_back(temp);
    }
    for(auto element : graph[v]){
        if(element==p) continue;
        dfs1(element, v);
    }
    s.pop();
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n;
    cin >> n;
    for(ll i = 0; i<n-1; i++){
        ll first, second;
        cin >> first >> second;
        first--;
        second--;
        graph[first].push_back(second);
        graph[second].push_back(first);
    }
    ll temp = dfs(0, 0);
    maxi=max(maxi, temp);
    for(ll i = 0; i<n; i++){
        if(graph[i].size()==1) dfs1(i, i);
    }
    ll mmm = 0;
    vector<ll> f;
    vector<ll> s;
    for(ll i = 0; i<need.size(); i++){
        for(ll j = 0; j<need.size(); j++){
            set<ll> values;
            for(auto element : need[i]) values.insert(element);
            for(auto element : need[j]) values.insert(element);
            if(values.size()>mmm){
                mmm=values.size();
                f=need[i];
                s=need[j];
            }
        }
    }
    cout << maxi << '\n';
    for(auto element : f) cout << element+1 << ' ';
    cout << '\n';
    for(auto element : s) cout << element+1 << ' ';
    cout << '\n';
}