
from math import sqrt, isqrt

p, q = tuple(map(int, input().split()))

def check(a, b, p, q, turn):
    while True:
        if a > b:
            a, b = b, a
        if p < 0 or q < 0: return False

        b_left = b %a 
        squares_taken = b // a 
        is_there_inbalance = squares_taken % 2
        squares_each_gets = squares_taken // 2
        first_gets = (is_there_inbalance + squares_each_gets) * a
        second_gets = squares_each_gets * a
        if turn:
            p -= first_gets
            q -= second_gets
        else:
            p-=second_gets
            q -= first_gets
        if is_there_inbalance == 1:
            turn = not turn
        b = b_left
    return True
    
def solve(p, q):
    s = p + q
    if p == 0:
        ans = sqrt(q)
        if ans == int(ans):
            return int(ans), int(ans)
        else:
            return -1
    if q == 0:
        ans= sqrt(p)
        if ans == int(ans):
            return int(ans), int(ans)
        else:
            return -1
    diff = p-q
    diff_root = sqrt(diff)
    if diff_root == int(diff_root):
        return int(diff_root), int(s//diff_root)
    for a in range(2, isqrt(s)):
        b = s//a
        if a * b != s:
            continue
        if check(a, b, p, q):
            return a, b
    return -1
# TODO: process the data
res = solve(p, q)
if res == -1:
    print(-1)
else:
    print(res[0], res[1])
