#include <iostream>
#include <math.h>
using namespace std;
int mas[99999][2];
int cnt[99999];
int branch[100000][1000];
int skeleton[100000];
int forbiden[100000];
int ways[100000][5];
int longest[10000];
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,brcnt=0;
    cin >> n;
    for (int i = 0; i < n - 1; i++)
    {
        cin >> mas[i][0] >> mas[i][1];
        cnt[mas[i][0]]++;
        cnt[mas[i][1]]++;
    }
    for (int i = 1; i <= n; i++)
    {
        if (cnt[i] == 1)
        {
            int l = 0;
            int q = i;
            int prev = -1;
            branch[brcnt][1] = i;
            l++;
            while(true)
            {
                bool flag = false;
                for (int j = 0; j < n - 1; j++)
                {
                    if (mas[j][0] == q && mas[j][1]!=prev)
                    {
                        prev = q;
                        q = mas[j][1];
                         break;
                    }
                    else if (mas[j][1] == q && mas[j][0] != prev)
                    {
                        prev = q;
                        q = mas[j][0];
                         break;
                    }
                }
                if (cnt[q] == 2 || cnt[prev]==2)
                {
                    branch[brcnt][l + 1] = q;
                    l++;
                    if (cnt[q] > 2)
                    {
                        branch[brcnt][0] = l;
                        break;
                    }
                }
                else
                {
                    branch[brcnt][0] = l;
                    break;
                }
            }
            brcnt++;
        }
    }
    //find the skeleton
    int q = branch[0][branch[0][0]];
    int prev= - 1;
    int skl = 0;
    skeleton[1] = q;
    skl++;
    bool flag = true;
    while (true)
    {
        flag = true;
        for (int j = 0; j < n - 1; j++)
        {
            if (mas[j][0] == q && mas[j][1] != prev && cnt[mas[j][1]] > 2)
            {
                prev = q;
                q = mas[j][1];
                flag = false;
                skeleton[skl+1] = q;
                skl++;
                break;
            }
            else if (mas[j][1] == q && mas[j][0] != prev && cnt[mas[j][0]] > 2)
            {
                prev = q;
                q = mas[j][0];
                flag = false;
                skeleton[skl+1] = q;
                skl++;
                break;
            }
        }
        if (flag)break;
    }
    for (int i = 1; i < skl / 2; i++)
    {
        swap(skeleton[skl + 1 - i], skeleton[i]);
    }
    q = skeleton[skl];
    prev = skeleton[skl - 1];
    
    while (true)
    {
        flag = true;
        for (int j = 0; j < n - 1; j++)
        {
            if (mas[j][0] == q && mas[j][1] != prev && cnt[mas[j][1]] > 2)
            {
                prev = q;
                q = mas[j][1];
                flag = false;
                skeleton[skl] = q;
                skl++;
                break;
            }
            else if (mas[j][1] == q && mas[j][0] != prev && cnt[mas[j][0]] > 2)
            {
                prev = q;
                q = mas[j][0];
                flag = false;
                skeleton[skl] = q;
                skl++;
                break;
            }
        }
        if (flag)break;
    }
    skeleton[0] = skl;
    int waycnt = 0;
    for (int i = 0; i < brcnt; i++)
    {
        for (int j = i+1; j < brcnt; j++)
        {
            ways[waycnt][0] = i;
            ways[waycnt][1] = j;
            int i1=-1, i2=-1;
            for (int k = 1; k <= skl; k++)
            {
                if (skeleton[k] == branch[i][branch[i][0]] || skeleton[k] == branch[j][branch[j][0]])
                {
                    if (i1 < 0)i1 = k;
                    else
                    {
                        i2 = k; break;
                    }
                }
            }
            if (i2 < 0)i2 = i1;
            ways[waycnt][2] = i1;
            ways[waycnt][3] = i2;
            ways[waycnt][4] = branch[i][0] + branch[j][0] - 2 + i2-i1;
            waycnt++;
        }
    }
    int maxlength = -1;
    int lcnt = 0;
    for (int i = 0; i < waycnt; i++)
    {
        if (ways[i][4] > maxlength)maxlength = ways[i][4];
    }
    for (int i = 0; i < waycnt; i++)
    {
        if (ways[i][4] == maxlength)
        {
            longest[lcnt]=i;
            lcnt++;
        }
    }
    int thebestc = 0;
    int thebesti=0;
    int thebestj=0;
    for (int i = 0; i < lcnt; i++)
    {
        for (int j = i + 1; j < lcnt; j++)
        {
            int city = 0;
            city = ways[longest[i]][4] + ways[longest[j]][4]+2;
            if (ways[longest[i]][0] == ways[longest[j]][0])
            {
                city -= branch[ways[longest[i]][0]][0] - 1;
            }
            if (ways[longest[i]][1] == ways[longest[j]][1])
            {
                city -= branch[ways[longest[i]][1]][0] - 1;
            }
            if (ways[longest[i]][0] == ways[longest[j]][1])
            {
                city -= branch[ways[longest[i]][0]][0] - 1;
            }
            if (ways[longest[i]][1] == ways[longest[j]][0])
            {
                city -= branch[ways[longest[i]][1]][1] - 1;
            }
            city -= max(0, ways[longest[i]][3] - ways[longest[j]][2] + 1);
            city -= max(0, ways[longest[i]][2] - ways[longest[j]][3] + 1);
            if (city > thebestc)
            {
                thebestc = city;
                thebesti = i;
                thebestj = j;
            }
        }
    }
    cout << ways[longest[thebesti]][4]+1 << '\n';
    for (int i = 1; i < branch[ways[longest[thebesti]][0]][0]; i++)
    {
        cout << branch[ways[longest[thebesti]][0]][i] << ' ';
    }
    if (skeleton[ways[longest[thebesti]][2]] == branch[ways[longest[thebesti]][0]][branch[ways[longest[thebesti]][0]][0]])
    {
        for (int i = ways[longest[thebesti]][2]; i <= ways[longest[thebesti]][3]; i++)
        {
            cout << skeleton[i] << ' ';
        }
    }
    else
    {
        for (int i = ways[longest[thebesti]][3]; i >= ways[longest[thebesti]][2]; i--)
        {
            cout << skeleton[i] << ' ';
        }
    }
    for (int i = branch[ways[longest[thebesti]][1]][0]-1; i >0 ; i--)
    {
        cout << branch[ways[longest[thebesti]][1]][i] << ' ';
    }
    cout << '\n';
    for (int i = 1; i < branch[ways[longest[thebestj]][0]][0]; i++)
    {
        cout << branch[ways[longest[thebestj]][0]][i] << ' ';
    }
    if (skeleton[ways[longest[thebestj]][2]] == branch[ways[longest[thebestj]][0]][branch[ways[longest[thebestj]][0]][0]])
    {
        for (int i = ways[longest[thebestj]][2]; i <= ways[longest[thebestj]][3]; i++)
        {
            cout << skeleton[i] << ' ';
        }
    }
    else
    {
        for (int i = ways[longest[thebestj]][3]; i >= ways[longest[thebestj]][2]; i--)
        {
            cout << skeleton[i] << ' ';
        }
    }
    for (int i = branch[ways[longest[thebestj]][1]][0]-1; i >0; i--)
    {
        cout << branch[ways[longest[thebestj]][1]][i] << ' ';
    }
}