def old_trace(adj, start, visited):
    new_visited = visited.copy()
    new_visited.append(start)
    results = []
    for finish in adj[start]:
        if finish not in visited:
            results.append(old_trace(adj, finish, new_visited))
    if results:
        return(max(results))
    else:
        return(len(new_visited), new_visited)

def new_trace(adj, start, visited, old_visited):
    new_visited = visited.copy()
    new_visited.append(start)
    results = []
    for finish in adj[start]:
        if finish not in visited:
            results.append(new_trace(adj, finish, new_visited, old_visited))
    if results:
        return(max(results))
    else:
        return(len([i for i in new_visited if i not in old_visited]), new_visited)

n = int(input())

adj = [[] for _ in range(n + 1)]
for _ in range(n - 1):
    u, v = map(int, input().split())
    adj[u].append(v)
    adj[v].append(u)

l = n
a = [0] * n
b = [0] * n
all_traces = []
for start1 in range(n):
    trace1 = old_trace(adj, start1, [])
    all_traces.append([trace1, []])
    for start2 in range(n):
        trace2 = new_trace(adj, start2, [], trace1[1])
        all_traces[start1][1].append(trace2)

max_sum = [0]
for trace1 in all_traces:
    max_new_trace_index = trace1[1].index(max(trace1[1]))
    if trace1[0][0] + trace1[1][max_new_trace_index][0] > max_sum[0]:
        max_sum = [trace1[0][0] + trace1[1][max_new_trace_index][0], trace1[0], trace1[1][max_new_trace_index][1]]

print(max_sum[1][0])
print(*max_sum[1][1])
print(*max_sum[2])
