import collections
n = int(input())

adj = [[] for _ in range(n + 1)]
for _ in range(n - 1):
    u, v = map(int, input().split())
    adj[u].append(v)
    adj[v].append(u)
l, max_path = 0, list()
def bfs(ind, view=set()):
    global l, max_path
    
    q = collections.deque([(ind, {ind}, 1, [ind])])

    while q:
        ind, view, res, path = q.pop()
        if l < res:
            max_path = [path.copy()]
            l = res
        elif l == res:
            max_path.append(path.copy())
        for i in adj[ind]:
            if i not in view:
                view.add(i)
                path.append(i)
                q.append((i, view.copy(), res+1, path.copy()))
                path.pop()
                view.remove(i)

    
    
for i in range(n+1):
    bfs(i)
print(l)
def main():
    min_need, res = float("inf"), ()
    for path_i in max_path:
        need = set(range(1, n+1))-set(path_i)
        for path_j in max_path:
            if len(need - set(path_j)) < min_need:
                min_need = len(need - set(path_j))
                res = (path_i, path_j)
    print(*res[0])
    print(*res[1])
    
main()
