n = int(input())

# edges = [False]*(n+1)
adj = [[] for _ in range(n + 1)]
for _ in range(n - 1):
    u, v = map(int, input().split())

    # edges[u] = not edges[u]
    # edges[v] = not edges[v]

    adj[u].append(v)
    adj[v].append(u)

# TODO: Process the tree

l = n
a = [0] * n
b = [0] * n

edges = [x for x in range(n+1) if len(adj[x]) == 1]

# if len(edges) != 2:
#     raise Exception

def wavefront(v, wave):
    if v in visited:
        return
    
    dists[v] = wave
    visited.add(v)
    for child in adj[v]:
        wavefront(child, wave+1)

def trace(cur):
    way = [cur]
    lvl = dists[cur]
    for l in reversed(range(lvl)):
        for v in adj[cur]:
            if dists[v] == l:
                way.append(v)
                cur = v
                break
    return tuple(way)


visited = set()
dists = [None]*(n+1)

wavefront(edges[0], 0)

way = trace(edges[1])

print(n)
print(" ".join(str(x) for x in way))
print(" ".join(str(x) for x in way))

