def abs(a, b) -> int:
    """Absolute value of the difference, i forgot
    what the function is in math module (>_<)"""

    if a > b:
        return a - b
    
    return b - a


def represent_as_squares(n) -> list[int]:
    """Represent a number as a sum of square numbers"""

    biggest_square = (n ** 0.5) // 1  # square root floored
    remainder = n - biggest_square ** 2

    if remainder != 0:
        remainder_squares = represent_as_squares(remainder)
        result = [biggest_square] + remainder_squares
    else:
        result = [biggest_square]
    
    return [x for x in result if x != 0]


p, q = map(int, input().split())

ps = represent_as_squares(p)
qs = represent_as_squares(q)


def solve(p, q, ps, qs) -> tuple:
    """Final steps as a function to use guard clauses"""

    if abs(len(ps), len(qs)) > 1:
        return (-1,)

    # Impossible for the 1st guy to take 0 pieces
    if len(ps) == 0:
        return (-1,)

    side = max(ps)

    side2 = (p + q) / side
    if side2 // 1 == side2:
        return (int(side), int(side2))

    return (-1,)


print(*solve(p, q, ps, qs))