#include <bits/stdc++.h>
using namespace std;
bool get_initial_cake_parameters(unsigned long long p, unsigned long long q, unsigned long long &m, unsigned long long &n){
    unsigned long long in_sqr = p + q;
    for (int i = 1; i <= sqrt(in_sqr); i++){
        if (in_sqr % i == 0){
            m = i;
            n = in_sqr / i;
        }
    }
    unsigned long long a = m;
    unsigned long long b = n;
    bool qu = false;
    while (in_sqr > 0){
        unsigned long long to_cutoff;
        if (a < b){
            to_cutoff = a;
            in_sqr -= to_cutoff*to_cutoff;
            b-=to_cutoff;
        }
        else{
            to_cutoff = b;
            in_sqr -= to_cutoff*to_cutoff;
            a-=to_cutoff;
        }
        if (!qu)
            p -= to_cutoff*to_cutoff;
        else
            q -= to_cutoff*to_cutoff;
        qu = !qu;
    }
    if (p < 0 || q < 0){
        return false;
    }
    else
        return true;
}
int main() {
    unsigned long long p,q;
    cin >> p >> q;
    
    // TODO: process the data
    unsigned long long m, n;
    if (get_initial_cake_parameters(p, q, m, n))
        cout << m << ' ' << n;
    else
        cout << -1 << '\n';
}