#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("Unroll-loops")
#pragma GCC target("avx,avx2,tune=native")
using namespace std;

const int N = 20001;
vector<vector<int>> adj(N);
int ans_length = 0;
vector <vector <int> > ans;

void f(int v, int past[N], int len[N], int prev[N]) {
    if (len[v] > ans_length) {
        ans.clear();
        ans_length = len[v];
    }
    if (len[v] == ans_length) {
        vector <int> current;
        int vert = v;
        while (vert != 0) {
            current.push_back(vert);
            vert = prev[vert];
        }
        ans.push_back(current);
    }

    for (int i = 0; i < adj[v].size(); i++) {
        if (past[adj[v][i]] == 0) {
            if (len[adj[v][i]] < len[v] + 1) {
                len[adj[v][i]] = len[v] + 1;
                past[adj[v][i]] = 1;
                prev[adj[v][i]] = v;
                f(adj[v][i], past, len, prev);
            }
        }
    }
    return;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n;
    cin >> n;

    if (n > 20) ans_length = 2;
    
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    for (int i = 1; i <= n; i++) {
        int been[N] = {0}, length[N] = {0}, previous[N] = {0};
        been[i] = 1;
        f(i, been, length, previous);
    }

    int l = ans_length + 1;
    int a1, b1;

    int max_elements = 0, now_elements = 0;
    map <int, bool> elements;
    for (int a = 0; a <= ans.size() / 2; a++) {
        for (int b = a; b <= ans.size() / 2; b++) {
            elements.clear();
            now_elements = 0;
            for (int i = 0; i <= l; i++) {
                if (!elements[ans[a][i]]) {
                    now_elements++;
                    elements[ans[a][i]] = true;
                }
                if (!elements[ans[b][i]]) {
                    now_elements++;
                    elements[ans[b][i]] = true;
                }
            }
            if (now_elements > max_elements) {
                max_elements = now_elements;
                a1 = a;
                b1 = b;
            }
        }
    }

    // TODO: Process the tree
    
    cout << l << endl;
    for (int x : ans[a1]) {
        cout << x << " ";
    }
    cout << endl;
    for (int x : ans[b1]) {
        cout << x << " ";
    }
    cout << endl;
    
}
