import math

p, q = map(int, input().split())

def sim(n, m):
    areaV, areaU, turn = 0, 0, 0

    a, b = n, m

    while True:
        if a < b:
            a, b = b, a

        if a == b:
            if turn == 0:
                areaV += a * a
            else:
                areaU += a * a
            break

        if turn == 0:
            areaV += b * b
        else:
            areaU += b * b
        a = a - b
        turn = 1 - turn
    return areaV, areaU


def solve(p, q):
    sum = p + q

    for d in range(1, int(math.isqrt(sum)) + 1):
        if sum % d != 0:
                continue
            
        m, n = d, sum // d

        a,b = sim(n,m)

        if a == p and b == q:
            return print(n,m)

        if n != m:
            a,b = sim(m,n)

            if a == p and b == q:
                return print(n,m)
    print(-1)
        
solve(p, q)
