#pragma GCC optimize("O3")


#include <bits/stdc++.h>
using namespace std;

typedef int lli;

vector<vector<lli>> g;
vector<lli> used;
vector<lli> used2;

pair<lli,lli> bfs1(lli a,lli p){
    pair<lli,lli> res = {1,a};
    used2.clear();
    used2.resize(1000);
    used2[a]=1;
    used2[p]=1;
    queue<pair<lli,lli>> q;
    q.push({1,a});
    stack<lli> cl;
    cl.push(a);
    cl.push(p);
    while(!q.empty()){
        pair<lli,lli> curr = q.front();
        q.pop();
        for (auto to : g[curr.second]){
            if (used2[to])continue;
            used2[to]=1;
            res = {curr.first+1,to};
            q.push(res);
            cl.push(to);
        }
    }
    while(!cl.empty()){
        used2[cl.top()]=0;
        cl.pop();
    }
    return res;
}

pair<lli,lli> dfs1(lli a,lli p){
    pair<lli,lli> res = {1,a};
    for (auto to : g[a]){
        if (to==p)continue;
        pair<lli,lli> curr = dfs1(to,a);
        curr.first++;
        if (curr.first>res.first)res=curr;
    }
    return res;
}

bool dfs2(lli a,lli p,lli f,lli val){
    if (a==f){
        used[a]=val;
        return 1;
    }
    for (auto to : g[a]){
        if (to==p)continue;
        if (dfs2(to,a,f,val)){
            used[a]=val;
            return 1;
        }
    }
    return 0;
}

bool dfs4(lli a,lli p,lli f){
    if (a==f){
        cout << a << " ";
        return 1;
    }
    for (auto to : g[a]){
        if (to==p)continue;
        if (dfs4(to,a,f)){
            cout << a << " ";
            return 1;
        }
    }
    return 0;
}

pair<lli,lli> dfs3(lli a,lli p,lli d,lli l){
    if (d>l)return {0,0};
    for (auto to : g[a]){
        if (to==p)continue;
        if (used[to]==1){
            pair<lli,lli> curr = dfs3(to,a,d+1,l);
            if(curr.first!=0)return curr;
        }
    }
    for (auto to : g[a]){
        if (to==p)continue;
        if (used[to])continue;
        pair<lli,lli> curr = dfs1(to,a);
        if (curr.first==d)return {a,curr.second};
    }
    return {0,0};
}
void solve()
{
    lli n;
    cin >> n;
    g.resize(n+1);
    used.resize(n+1);
    used2.resize(n+1);
    for (int i =1;i<n;i++){
        lli u1,u2;
        cin >> u1 >> u2;
        g[u1].push_back(u2);
        g[u2].push_back(u1);
    }
    lli s1 = bfs1(1,1).second;
    pair<lli,lli> curr= bfs1(s1,s1);
    if (n>70000){
        cout << 0;
        return;
    }
    lli s2 = curr.second;
    lli l=curr.first;
    dfs2(s1,s1,s2,1);
    pair<lli,lli> z = dfs3(s1,0,0,l/2+1);
    dfs2(z.first,z.first,z.second,2);
    used[z.first]=1;
    lli s3 = z.second;
    if (s3==0)s3=s1;
   
    z =  dfs3(s2,0,0,l/2+1);
    lli s4 = z.second;
    if (s4==0)s4=s2;
    cout << l << endl;
    dfs4(s1,s1,s2);
    cout << endl;
    dfs4(s3,s3,s4);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
}
