#include <bits/stdc++.h>
using namespace std;


bool isItPossible(int sizeX, int sizeY, int p, int q) {
    int newP = 0;
    int newQ = 0;
    int remainingX = sizeX;
    int remainingY = sizeY;
    bool vusTurn = true;
    int S = sizeX * sizeY;
    while (newP + newQ < S) {
        int largestSquareSize = remainingX < remainingY ? remainingX * remainingX : remainingY * remainingY;
        // we can optimize this with a pointer
        if (vusTurn) {
            newP += largestSquareSize;
        } else {
            newQ += largestSquareSize;
        }
        vusTurn = !vusTurn;
        if (remainingX < remainingY) {
            remainingY -= remainingX;
        } else {
            remainingX -= remainingY;
        }
    }
    //printf("scenario %d x %d: p %d, q %d\n", sizeX, sizeY, newP, newQ);
    // may need to add a check with newQ also but theoretically we dont need to
    if (newP == p) {
        return true;
    }
    return false;
}

int main() {
    int p;
    int q;
    cin >> p >> q;

    int totalSize = p + q;
    for (int sizeX = 0; sizeX < totalSize; sizeX++) {
        float sizeY = (float)totalSize / sizeX;
        if (int(sizeY) - sizeY == 0) {
            if (isItPossible(sizeX, sizeY, p, q)) {
               //TODO: here we verify if its even possible
                cout << sizeX << ' ' << (int)sizeY << '\n';
                //printf("combo: %d x %d\n", sizeX, (int)sizeY);
                return 0;
            }

        }
    }

    cout << -1 << '\n';
    return 0;
}
