#include <bits/stdc++.h>
using namespace std;


bool isItPossible(long sizeX, long sizeY, long p, long q) {
    if (sizeX == 1 && sizeY % 2 == 0) {
        return p==q;
    }
    long newP = 0;
    long newQ = 0;
    long remainingX = sizeX;
    long remainingY = sizeY;
    bool vusTurn = true;
    long S = sizeX * sizeY;
    while (newP + newQ < S) {
        long largestSquareSize = remainingX < remainingY ? remainingX * remainingX : remainingY * remainingY;
        // we can(not) optimize this with a pointer
        if (vusTurn) {
            newP += largestSquareSize;
        } else {
            newQ += largestSquareSize;
        }
        vusTurn = !vusTurn;
        if (remainingX < remainingY) {
            remainingY -= remainingX;
        } else {
            remainingX -= remainingY;
        }
    }
    //printf("scenario %d x %d: p %d, q %d\n", sizeX, sizeY, newP, newQ);
    // may need to add a check with newQ also but theoretically we dont need to
    return newP == p;
}

int main() {
    long p;
    long q;
    cin >> p >> q;

    long totalSize = p + q;
    for (long sizeX = 1; sizeX < totalSize/2; sizeX++) {
        long sizeY = totalSize / sizeX;
        if (sizeX*sizeY == totalSize) {
            if (isItPossible(sizeX, sizeY, p, q)) {
               //TODO: here we verify if its even possible
                cout << sizeX << ' ' << (long)sizeY << '\n';
                //printf("combo: %d x %d\n", sizeX, (int)sizeY);
                return 0;
            }

        }
    }

    cout << -1 << '\n';
    return 0;
}
