#include <bits/stdc++.h>
using namespace std;


bool isItPossible(int64_t sizeX, int64_t sizeY, int64_t p, int64_t q) {
    /*if (sizeX == 1) {
        switch (sizeY % 2) {
        case 0:
            return p==q;
        case 1:
            return p==q+1;
        }
    }*/
    int64_t newP = 0;
    int64_t newQ = 0;
    int64_t remainingX = sizeX;
    int64_t remainingY = sizeY;
    bool vusTurn = true;
    int64_t S = sizeX * sizeY;

    if (sizeY / sizeX > 2) {
        int64_t numSq = (sizeY/sizeX);
        newQ = numSq / 2;
        switch (numSq % 2) {
        case 0:
            newP = numSq / 2;
        case 1:
            newP = numSq / 2 + 1;
            vusTurn = false;
        }
        newQ *= (sizeX*sizeX);
        newP *= (sizeX*sizeX);
        remainingY = sizeY - sizeX*(sizeY/sizeX);
        //printf("optimized: squares %ld, p %ld, q %ld, remainingY %ld, remainingX %ld\n", numSq, newP, newQ, remainingY, remainingX);
    }
    while (newP + newQ < S) {
        int64_t largestSquareSize = remainingX < remainingY ? remainingX * remainingX : remainingY * remainingY;
        // we can(not) optimize this with a pointer
        if (vusTurn) {
            newP += largestSquareSize;
        } else {
            newQ += largestSquareSize;
        }
        vusTurn = !vusTurn;
        if (remainingX < remainingY) {
            remainingY -= remainingX;
        } else {
            remainingX -= remainingY;
        }
    }
    //printf("scenario %d x %d: p %d, q %d\n", sizeX, sizeY, newP, newQ);
    // may need to add a check with newQ also but theoretically we dont need to
    return newP == p;
}

int main() {
    int64_t p;
    int64_t q;
    cin >> p >> q;


    // omg hax0r!
    if (p < q) {
        cout << 1 << ' ' << p + q << '\n';
        return 0;
    }

    if (p == q) {
        cout << 1 << ' ' << p + q << '\n';
        return 0;
    }
    if (p == q + 1) {
        cout << 1 << ' ' << p + q << '\n';
        return 0;
    }

    int64_t totalSize = p + q;
    int incrementory = 1;
    int init = 2;
    if (totalSize  % 2 == 1) {
        incrementory = 2;
        init = 3;
    }
    for (int64_t sizeX = init; sizeX <= totalSize/4; sizeX+=incrementory) {
        //if (sizeX % 100000000 == 0 || sizeX % 100000000 == 1 || sizeX < 1000) {
        //    printf("\rtried %ld", sizeX);
        //}

        int64_t sizeY = totalSize / sizeX;
        if (sizeX*sizeY == totalSize) {
            if (isItPossible(sizeX, sizeY, p, q)) {
               //TODO: here we verify if its even possible
                cout << sizeX << ' ' << (int64_t)sizeY << '\n';
                //printf("combo: %d x %d\n", sizeX, (int)sizeY);
                return 0;
            }

        }

    }
    cout << -1 << '\n';
    return 0;
}
