#include <bits/stdc++.h>
using namespace std;

int dig_pos[10];
int last_pair[1000000];
vector<int> len_pairs;

void solve() {
    int n; cin >> n;
    string s; cin >> s;

    len_pairs.clear();
    for (int i = 0; i < 10; ++i)
        dig_pos[i] = -1;
    for (int i = 0; i < n; ++i)
        last_pair[i] = -1;
    
    int q_smaller_pairs = 0;
    for (int i = 0; i < n; ++i){
        if (dig_pos[s[i] - '0'] != -1)
            last_pair[i] = i - dig_pos[s[i] - '0'] - 1;
        for (int j = dig_pos[s[i] - '0'] + 1; j < i; ++j)
            if (last_pair[j] < last_pair[i] && last_pair[j] != -1)
                ++q_smaller_pairs;

        if (dig_pos[s[i] - '0'] != -1)
            len_pairs.push_back(i - dig_pos[s[i] - '0'] - 1 - q_smaller_pairs);
        dig_pos[s[i] - '0'] = i;
    }
    sort(len_pairs.begin(), len_pairs.end());

    bool ans = true;
    for (int i = 0; i < len_pairs.size(); ++i)
        if (len_pairs[i] < i + 1)
            ans = false;
    
    cout << (ans ? "Yes\n" : "No\n");
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int t; cin >> t;
    while(t--)solve();
}