#include <bits/stdc++.h>
using namespace std;
int dfs(int i,int depth,vector<bool>used,vector<vector<int>>&adj,pair<vector<int>,int>&out){
    //cout<<"dfs :"<<i<<'\n';
    used[i]=1;
    for(int j:adj[i]){
        if(!used[j]){
            dfs(j,depth+1,used,adj,out);
        }
    }
    //cout<<"dfs out :"<<i<<" pair "<<out.first<<" "<<out.second<<'\n';
    if(out.second<depth){
        out.second=depth;
        out.first={i};
    }
    else if(out.second==depth){
        out.first.push_back(i);
    }
    return 0;
}
int dfs3(int end,int i,vector<bool>used,vector<vector<int>>&adj,vector<int>&out){
    //cout<<"dfs :"<<i<<'\n';
    if(i==end){
        out.push_back(i);
        return 1;
    }
    used[i]=1;
    for(int j:adj[i]){
        if(!used[j]){
            int d=dfs3(end,j,used,adj,out);
            if(d==1){
                out.push_back(i);
                return 1;
            }
        }
    }
    return 0;
}
int dfs1(int end,int i,vector<bool>used,vector<vector<int>>&adj,vector<bool>&out){
    //cout<<"dfs :"<<i<<'\n';
    used[i]=1;
    if(i==end){
        out[i]=1;
        return 1;
    }
    for(int j:adj[i]){
        if(!used[j]){
            int d=dfs1(end,j,used,adj,out);
            if(d==1){
                out[i]=1;
                return 1;
            }
        }
    }
    return 0;
}
int dfs2(int end,int i,vector<bool>used,vector<vector<int>>&adj,vector<bool>&patha,int&c){
    //cout<<"dfs :"<<i<<'\n';
    if(i==end){
        if(patha[i]){
            c++;
        }
        return 1;
    }
    used[i]=1;
    for(int j:adj[i]){
        if(!used[j]){
            int d=dfs2(end,j,used,adj,patha,c);
            if(d==1){
                if(patha[i]){
                    c++;
                }
                return 1;
            }
        }
    }
    return 0;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n;
    cin >> n;
    
    vector<vector<int>> adj(n+1);
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        u--;v--;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }
    
    // TODO: Process the tree
    vector<bool>used(n);
    pair<vector<int>,int>tmp={{},-1};
    dfs(0,1,used,adj,tmp);
    vector<int>&starts=tmp.first;
    vector<pair<int,int>>paths;
    int lenght=-1;
    for(int start:starts){
        vector<bool>used1(n);
        pair<vector<int>,int>tmp1={{},-1};
        dfs(start,1,used1,adj,tmp1);
        if(lenght==tmp1.second){
            for(int e:tmp1.first){
                paths.emplace_back(start,e);
            }
        }
        if(lenght<tmp1.second){
            paths={};
            for(int e:tmp1.first){
                paths.emplace_back(start,e);
            }
            lenght=tmp1.second;
        }
    }
    int mxc=INT_MAX;
    pair<pair<int,int>,pair<int,int>>best;
    for (int i=0;i<paths.size();i++) {
        for(int j=0;j<i;j++){
            pair<int,int> x=paths[i],y=paths[j];
            vector<bool>used1(n);
            vector<bool>used2(n);
            vector<bool>patha(n);
            int d=0;
            dfs1(x.second,x.first,used1,adj,patha);
            dfs2(y.second,y.first,used1,adj,patha,d);
            //cout<<"d "<<d<<"\n";
            if(d<mxc){
                best={x,y};
                mxc=d;
            }
        }
    }
    //cout<<mxc<<", "<<best.first.first<<" "<<best.first.second<<", ";
    //cout<<best.second.first<<" "<<best.second.second<<" ";

    int l = lenght;
    vector<int> a, b;
    vector<bool>used2(n);
    dfs3(best.first.second,best.first.first,used2,adj,a);
    dfs3(best.second.second,best.second.first,used2,adj,b);
    cout << l<<"\n";
    for (int x : a) {
        cout << x+1 << " ";
    }
    cout << '\n';
    for (int x : b) {
        cout << x+1 << " ";
    }
    cout << '\n';
    
}
