#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<pll, pll> ppll;
const ll SIZ = (ll)(1e5 + 5), LONGBOI = (ll)(1e12 + 5);
mt19937 REALrandom(chrono::system_clock::to_time_t(chrono::system_clock::now()));

struct str {
    ll p1, d1;
    ll p2, d2;
    ll theirPar;
};

//struct mycomp {
//    bool operator()(str a, str b) const {
//
//    }
//};
//
//bool operator < (str a, str b) {
//
//}

ll n, v1, v2, distBetweenPoints;
str p0, p1, p2;
vector<ll> roads[SIZ];

str findThePoints(ll we, ll par, ll dep, set<ll> toforget) {
    str k, ans;
    ans.d1 = dep; ans.p1 = we;
    ans.d2 = 0; ans.p2 = 0;
    ans.theirPar = we;
    for (auto x : roads[we]) {
        if (x == par || toforget.count(x)) continue;
        k = findThePoints(x, we, dep + 1, toforget);
        if (k.d1 > ans.d1) {
            ans.p1 = k.p1; ans.d1 = k.d1;
            ans.p2 = k.p2; ans.d2 = k.d2;
            ans.theirPar = k.theirPar;
        }
        else if (k.d1 == ans.d1) {
            ans.p2 = k.p1; ans.d2 = k.d1;
            ans.theirPar = we;
        }
    }
    //cout << "we = " << we << " par = " << par << " depth = " << dep << " returning = ";
    //cout << "{" << ans.d1 << ", " << ans.p1 << "} {" << ans.d2 << ", " << ans.p2 << "}" << endl;
    return ans;
}

ll dfsDist(ll we, ll par, ll need, ll dep) {
    if (need == 0) return 0;
    ll ans = 0;
    if (we == need) return dep;
    for (auto x : roads[we]) {
        if (x == par) continue;
        ans = max(ans, dfsDist(x, we, need, dep + 1));
    }
    return ans;
}

bool dfsWriteAns(ll we, ll par, ll need) {
    if (need == 0) return 0;
    ll ans = 0;
    if (we == need) {
        cout << we << " ";
        return true;
    }
    for (auto x : roads[we]) {
        if (x == par) continue;
        if (dfsWriteAns(x, we, need)) {
            cout << we << " ";
            return true;
        }
    }
    return false;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 1; i < n; i++) {
        cin >> v1 >> v2;
        roads[v1].push_back(v2);
        roads[v2].push_back(v1);
    }
    set<ll> toforget;
    p0 = findThePoints(1, 1, 1, toforget); toforget.clear();
    distBetweenPoints = dfsDist(p0.p1, p0.p1, p0.p2, 1);
    toforget.insert(p0.p2);
    p1 = findThePoints(p0.p1, p0.p1, 1, toforget); toforget.clear();
    toforget.insert(p0.p1); toforget.insert(p1.p1);
    p2 = findThePoints(p0.p2, p0.p2, 1, toforget); toforget.clear();
    //cout << "POINTS (dep, num) : point1 = {" << p0.d1 << ", " << p0.p1 << "} point2 = {" << p0.d2 << ", " << p0.p2 << "} and their par = " << p0.theirPar << endl;
    //cout << "distance Between this deez points = " << distBetweenPoints << endl;
    //cout << "POINTS FOR 1 POINT : " << endl;
    //cout << "POINTS (dep, num) : point1 = {" << p1.d1 << ", " << p1.p1 << "} point2 = {" << p1.d2 << ", " << p1.p2 << "} and their par = " << p1.theirPar << endl;
    //cout << "POINTS FOR 2 POINT : " << endl;
    //cout << "POINTS (dep, num) : point1 = {" << p2.d1 << ", " << p2.p1 << "} point2 = {" << p2.d2 << ", " << p2.p2 << "} and their par = " << p2.theirPar << endl;



    ll distAns = p1.d1;
    if (distAns < p2.d1) {
        distAns = p2.d1;
        p1.d1 = p2.d1;
        p1.p1 = p2.p1;
        p0.p1 = p0.p2;
    }
    else if (distAns > p2.d1) {
        p2.d1 = p1.d1;
        p2.p1 = p1.p1;
        p0.p2 = p0.p1;
    }
    if (distAns < distBetweenPoints) {
        cout << distBetweenPoints << endl;
        dfsWriteAns(p0.p1, p0.p1, p0.p2); cout << endl;
        dfsWriteAns(p0.p1, p0.p1, p0.p2); cout << endl;
        return 0;
    }
    cout << distAns << endl;
    dfsWriteAns(p0.p1, p0.p1, p1.p1); cout << endl;
    if (p0.d2 == 0) dfsWriteAns(p0.p1, p0.p1, p1.p1);
    else if (p0.d2 != 0) dfsWriteAns(p0.p2, p0.p2, p2.p1);
    cout << endl;
    return 0;
}