import copy
def min_space(n, s):
    table = {
        "0": [-1, -1, -1, -1, -1],
        "1": [-1, -1, -1, -1, -1],
        "2": [-1, -1, -1, -1, -1],
        "3": [-1, -1, -1, -1, -1],
        "4": [-1, -1, -1, -1, -1],
        "5": [-1, -1, -1, -1, -1],
        "6": [-1, -1, -1, -1, -1],
        "7": [-1, -1, -1, -1, -1],
        "8": [-1, -1, -1, -1, -1],
        "9": [-1, -1, -1, -1, -1]
    }
    i = 0
    for x in s:
        if table[x][0] == -1:
            table[x][0] = 1
            table[x][2] = i
        elif table[x][0] == 1:
            table[x][0] += 1
            l = i-table[x][2]-1
            table[x][1] = l
            table[x][3] = i
            table[x][4] = i
        else:
            table[x][0] += 1
            l = i-table[x][4]-1
            if table[x][1]>l:
                table[x][1] = l
                table[x][2] = table[x][3]
                table[x][3] = i
            table[x][4] = i
        i+=1

    min_length = n+1
    l = -1
    r = -1
    for j in range(0, 10):
        x = str(j)
        if table[x][1]<min_length and table[x][0] > 1:
            min_length = table[x][1]
            l = table[x][2]
            r = table[x][3]

    if l == -1 or r == -1:
        return -1, -1, -1
    else:
        return min_length, l, r

def Vus(n, s):
    min_length, l, r = map(int, min_space(n, s))
    scopyL = copy.copy(s)
    scopyR = copy.copy(s)
    del scopyL[l]
    del scopyR[r]
    min_lengthL, lL, rL = map(int, min_space(n-1, scopyL))
    min_lengthR, lR, rR = map(int, min_space(n-1, scopyR))
    if min_lengthL<=min_lengthR:
        del s[l]
    else:
        del s[r]
    
    return s, n-1

def Us(n, s):
    min_length, l, r = map(int, min_space(n, s))
    if min_length>0:
        del s[l+1]
        return s, n-1
    else:
        return s, n

def win(n, s):
    min_length, l, r = map(int, min_space(n, s))
    if min_length == -1:
        return "Yes"
    elif min_length == 0:
        return "No"
    else:
        return 0

def solve():
    n = int(input())
    s = input()
    s = list(s)
    i = 0
    while True:
        if i%2 == 0:
            arr = Vus(n, s)
            s = arr[0]
            n = arr[1]
            # print(s, "after VUS")
            w = win(n, s)
            if not w == 0:
                print(w)
                return 0
        else:
            arr = Us(n, s)
            s = arr[0]
            n = arr[1]
            # print(s, "after US")
            w = win(n, s)
            if not w == 0:
                print(w)
                return 0
        
        i+=1
    

t = int(input())
for _ in range(t):
    solve()
